import { AfterViewInit, ElementRef, EventEmitter, OnChanges, OnDestroy } from '@angular/core';
import { Grid, UserConfig } from 'gridjs';
import type { GridEvents } from 'gridjs/dist/src/events';
import type Header from 'gridjs/dist/src/header';
import type { Language, Translator } from 'gridjs/dist/src/i18n/language';
import type Pipeline from 'gridjs/dist/src/pipeline/pipeline';
import type { Plugin, PluginManager } from 'gridjs/dist/src/plugin';
import type { ServerStorageOptions } from 'gridjs/dist/src/storage/server';
import type Storage from 'gridjs/dist/src/storage/storage';
import type Tabular from 'gridjs/dist/src/tabular';
import type { OneDArray, TColumn } from 'gridjs/dist/src/types';
import type Dispatcher from 'gridjs/dist/src/util/dispatcher';
import type { EventEmitter as GridJsEventEmitter } from 'gridjs/dist/src/util/eventEmitter';
import type { PaginationConfig } from 'gridjs/dist/src/view/plugin/pagination';
import type { SearchConfig } from 'gridjs/dist/src/view/plugin/search/search';
import type { GenericSortConfig } from 'gridjs/dist/src/view/plugin/sort/sort';
import { GridJsClassName, GridJsConfig, GridJsData, GridJsStyles } from './types';
export declare class GridJsAngularComponent implements AfterViewInit, OnChanges, OnDestroy, GridJsConfig {
    private nativeElement;
    private gridInstance;
    private initialized;
    private listeners;
    gridConfig: Partial<UserConfig>;
    plugins: Plugin[];
    eventEmitter: GridJsEventEmitter<GridEvents>;
    dispatcher: Dispatcher<any>;
    plugin: PluginManager;
    data?: GridJsData;
    server?: ServerStorageOptions;
    header?: Header;
    from: HTMLElement;
    storage: Storage<any>;
    pipeline: Pipeline<Tabular>;
    autoWidth: boolean;
    width: string;
    height: string;
    translator: Translator;
    style?: Partial<GridJsStyles>;
    className?: Partial<GridJsClassName>;
    fixedHeader: boolean;
    columns: OneDArray<TColumn | string>;
    search: SearchConfig | boolean;
    pagination: PaginationConfig | boolean;
    sort: GenericSortConfig | boolean;
    language: Language;
    beforeLoad: EventEmitter<void>;
    gridLoad: EventEmitter<any>;
    cellClick: EventEmitter<any>;
    rowClick: EventEmitter<any>;
    constructor(elementDef: ElementRef);
    ngAfterViewInit(): void;
    ngOnChanges(changes: any): void;
    ngOnDestroy(): void;
    getGridInstance(): Grid;
    updateConfig(config: Partial<UserConfig>): void;
    private registerEvents;
    private unregisterEvents;
    private registerPlugins;
    private getConfig;
}
